/* This class plays .au files. */

package cgmud.audio;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import sun.audio.*;


public class Audio {

    private InputStream d_stream;


    /* ----- constructors ----- */

    public Audio(String aufile, int repeat)
    throws FileNotFoundException, IOException
    {
	d_stream = new RepeatedInputStream(
	    new FileInputStream(aufile), repeat
	);
    }

    public Audio(String aufile)
    throws FileNotFoundException, IOException
    {
	this(aufile, 1);
    }


    /* ----- methods ----- */

    public void play() {
	AudioPlayer.player.start(d_stream);
    }

    public void stop() {
	if (d_stream != null) {
	    AudioPlayer.player.stop(d_stream);
	    d_stream = null;
	}
    }


    /* ----- testing code ----- */
    public static void main(String[] args)
    throws Exception
    {
	Audio au = new Audio(args[0], Integer.parseInt(args[1]));
	au.play();
	Thread.sleep(10000);
    }
}
