/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a absolute-draw-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class AbsDraw extends Effect {

    private short d_x;
    private short d_y;


    public AbsDraw(ByteSequence bs, boolean twobyte)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	if (twobyte) {
	    d_x = bs.getShort();
	    d_y = bs.getShort();
	} else {
	    d_x = (short) (bs.getByte() & 0x00ff);
	    d_y = (short) (bs.getByte() & 0x00ff);
	}
    }

    public void run(Component com) throws EffectException {
	if (d_polygon == null) {
	    ((BackedCanvas) com).getBackingGraphics()
		.drawLine(d_ptX, d_ptY, d_x, d_y);
	} else {
	    d_polygon.addPoint(d_x, d_y);
	}
	d_ptX = d_x;
	d_ptY = d_y;
    }

}
