/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a absolute-move-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;


public class AbsMove extends Effect {

    private short d_x; // unsigned
    private short d_y; // unsigned


    public AbsMove(ByteSequence bs, boolean twobyte)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	if (twobyte) {
	    d_x = bs.getShort();
	    d_y = bs.getShort();
	} else {
	    d_x = (short) (bs.getByte() & 0x00ff);
	    d_y = (short) (bs.getByte() & 0x00ff);
	}
    }

    public void run(Component com) throws EffectException {
	d_ptX = 0x0000ffff & d_x;
	d_ptY = 0x0000ffff & d_y;
	if (d_polygon != null) {
	    int lx = d_polygon.npoints - 1;
	    d_polygon.xpoints[lx] = d_ptX;
	    d_polygon.ypoints[lx] = d_ptY;
	}
    }


}
