/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a call-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;
import cgmud.main.Globals;


public class Call extends Effect {

    private Effect d_body;	// null if not resolved
    private int d_key;		// valid if not resolved

    public Call(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_body = null;
	d_key = bs.getInt();
    }

    public void run(Component com) throws EffectException {
	if (d_body == null) {
	    try {
		d_body = (Effect) Globals.theEffects.getItem(d_key);
	    } catch (ClassCastException ex) {
		throw new EffectException("not an effects proc @#" + d_key);
	    }
	    if (d_body == null) {
		throw new EffectException("can't call #" + d_key);
	    }
	}
	d_body.run(com);
    }

}
