/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a circle-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import java.awt.Graphics;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class Circle extends Effect {

    private int d_radius;
    private boolean d_fill;


    public Circle(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_radius = 0x0000ffff & (int) bs.getShort();
	d_fill = bs.getBoolean();
    }

    public void run(Component com) throws EffectException {
	Graphics gr = ((BackedCanvas) com).getBackingGraphics();
	// When asked to draw a circle in a rectangle of even dimensions,
	// Java seems to draw one that is one greater than those dimensions.
	// So, we have to compensate here with by subtracting 1. -cg
	if (d_fill) {
	    gr.fillOval(
		d_ptX - d_radius, d_ptY - d_radius,
		2 * d_radius - 1, 2 * d_radius - 1
	    );
	} else {
	    gr.drawOval(
		d_ptX - d_radius, d_ptY - d_radius,
		2 * d_radius - 1, 2 * d_radius - 1
	    );
	}
    }

}
