/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a define-tile-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;
import cgmud.main.Globals;
import cgmud.ui.Tile;


public class DefineTile extends Effect {

    private short d_id;
    private short d_xpar;
    private int d_wid;
    private int d_hei;
    private byte[] d_data;


    public DefineTile(ByteSequence bs, boolean withTransparent)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_id = bs.getShort();
	if (withTransparent) {
	    d_xpar = bs.getShort();
	} else {
	    d_xpar = -1;
	}
	d_wid = (bs.getByte() & 0x000000ff);
	d_hei = (bs.getByte() & 0x000000ff);
	d_data = bs.getBlock(d_wid * d_hei);
    }

    public void run(Component com) throws EffectException {
	Tile ti = new Tile(d_wid, d_hei, d_data, d_xpar, com);
	Globals.theTiles.insertItem((int) d_id, ti);
    }

}
