/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a sequence of effects: an entire effect proc,
   or the Then or Else clause of an IfFound. */

package cgmud.effect;

import java.awt.Component;
import java.util.Vector;
import cgmud.base.ByteSequence;


public class EffectSequence extends Effect {

    private Vector d_seq;

    public EffectSequence(ByteSequence bs) {
	d_seq = new Vector();
	while (! bs.atEnd()) {
	    switch (bs.peekByte()) {
		case ELSE: case FI: case POLYGON_END: return;
		default: d_seq.addElement(extract(bs));
	    }
	}
    }

    public void run(Component com) throws EffectException {
	int sz = d_seq.size();
	for (int ix = 0; ix < sz; ix += 1) {
	    ((Effect) d_seq.elementAt(ix)).run(com);
	}
    }

}
