/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents the effects that a client supports. */

package cgmud.effect;

import cgmud.base.ByteSequence;


public class EffectsInfo {

    static final int BEGIN_KEY_LEN = 24;

    public byte[] graphicsType = new byte[20];
    public short screenRows, screenCols, screenColours;
    public short fontAscent, fontDescent, fontLeading,
		 fontHeight, fontWidth;
    public short textWidth, textHeight;
    public short version;
    public boolean canEdit, canGetString, canQueryFile, canWizard;
    public boolean graphicsOn, graphicsPalette;
    public boolean voiceOn, soundOn, musicOn;


    public static int BYTE_SIZE = BEGIN_KEY_LEN + 52;


    /* ----- constructors ----- */

    public EffectsInfo() { }

    public byte[] byteData() {
	byte[] key = new byte[BEGIN_KEY_LEN];
	for (int i = 0; i != BEGIN_KEY_LEN; i += 1) {
	    key[i] = (byte) (i * i);
	}
	ByteSequence bs = new ByteSequence(BYTE_SIZE);
	bs.appendBlock(BEGIN_KEY_LEN, key);
	bs.appendBlock(graphicsType.length, graphicsType);
	bs.appendShort(screenRows);
	bs.appendShort(screenCols);
	bs.appendShort(screenColours);
	bs.appendShort(fontAscent);
	bs.appendShort(fontDescent);
	bs.appendShort(fontLeading);
	bs.appendShort(fontHeight);
	bs.appendShort(fontWidth);
	bs.appendShort(textWidth);
	bs.appendShort(textHeight);
	bs.appendShort(version);
	bs.appendBoolean(canEdit);
	bs.appendBoolean(canGetString);
	bs.appendBoolean(canQueryFile);
	bs.appendBoolean(canWizard);
	bs.appendBoolean(graphicsOn);
	bs.appendBoolean(graphicsPalette);
	bs.appendBoolean(voiceOn);
	bs.appendBoolean(soundOn);
	bs.appendBoolean(musicOn);
	bs.appendBoolean(false);	// pad out same as C does
	return bs.getArray();
    }

}
