/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a ellipse-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import java.awt.Graphics;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class Ellipse extends Effect {

    private int d_radx, d_rady;
    private boolean d_fill;


    public Ellipse(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_radx = 0x0000ffff & (int) bs.getShort();
	d_rady = 0x0000ffff & (int) bs.getShort();
	d_fill = bs.getBoolean();
    }

    public void run(Component com) throws EffectException {
	Graphics gr = ((BackedCanvas) com).getBackingGraphics();
	if (d_fill) {
	    gr.fillOval(
		d_ptX - d_radx + 1, d_ptY - d_rady + 1,
		2 * d_radx, 2 * d_rady
	    );
	} else {
	    gr.drawOval(
		d_ptX - d_radx + 1, d_ptY - d_rady + 1,
		2 * d_radx, 2 * d_rady
	    );
	}
    }

}
