/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents an if-found effect and its subsequences. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;


public class IfFound extends Effect {

    private Effect d_then; // really a sequence
    private Effect d_else; // really a sequence

    public IfFound(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_then = new EffectSequence(bs);
	switch (bs.getByte()) {
	    case ELSE:
		d_else = new EffectSequence(bs);
		switch (bs.getByte()) {
		    case ELSE:
			throw new EffectFormException
			    ("extra ELSE parsing IfFound");
		    case FI:
			return;
		    default:
			throw new EffectFormException
			    ("missing FI after IfFound/Else");
		}
		// notreached: break;
	    case FI:
		d_else = null;
		break;
	    default:
		throw new EffectFormException
		    ("missing FI after IfFound");
	}
    }

    public void run(Component com) throws EffectException {
	if (d_foundFlag) {
	    if (d_then != null) d_then.run(com);
	} else {
	    if (d_else != null) d_else.run(com);
	}
    }

}
