/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a pixel-row-effect and its body. */

package cgmud.effect;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import cgmud.base.ByteSequence;
import cgmud.main.Globals;
import cgmud.ui.BackedCanvas;
import cgmud.ui.PenSet;


public class PixelRow extends Effect {

    private byte d_pixels[];

    public PixelRow(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_pixels = bs.getBlock(bs.getShort());
    }

    public void run(Component com) throws EffectException {
	Graphics gr = ((BackedCanvas) com).getBackingGraphics();
	Color oldcolor = gr.getColor();
	for (int ix = 0; ix < d_pixels.length; ix += 1) {
	    int co = Globals.thePenSet.getColorint(d_pixels[ix] & 0xff);
	    gr.setColor(new Color(co));
	    gr.fillRect(d_ptX + ix, d_ptY, 1, 1);
	}
	gr.setColor(oldcolor);
    }

}
