/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a place-cursor-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;
import cgmud.ui.IconedCanvas;


public class PlaceCursor extends Effect {

    private short d_x;	// unsigned
    private short d_y;	// unsigned


    public PlaceCursor(ByteSequence bs, boolean twobyte)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	if (twobyte) {
	    d_x = bs.getShort();
	    d_y = bs.getShort();
	} else {
	    d_x = (short) ((int) bs.getByte() & 0x00ff);
	    d_y = (short) ((int) bs.getByte() & 0x00ff);
	}
    }

    public void run(Component com) throws EffectException {
	IconedCanvas ic = (IconedCanvas) com;
	ic.moveIcon(0x0000ffff & (int) d_x,
		    0x0000ffff & (int) d_y);
	ic.showIcon(true);
    }

}
