/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a polygon-start-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import java.awt.Polygon;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class PolygonStart extends Effect {

    private Effect d_effseq;


    public PolygonStart(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_effseq = new EffectSequence(bs);
	switch (bs.getByte()) {
	    case POLYGON_END: return;
	    default:
		throw new EffectFormException
		    ("missing PolygonEnd after PolygonStart");
	}
    }

    public void run(Component com) throws EffectException {
	d_polygon = new Polygon();
	d_polygon.addPoint(d_ptX, d_ptY);
	d_effseq.run(com);

	/* close it if unclosed */
	int ix = d_polygon.npoints - 1;
	if ((d_polygon.xpoints[0] != d_polygon.xpoints[ix])
	 || (d_polygon.ypoints[0] != d_polygon.ypoints[ix]))
	{
	    d_polygon.addPoint(d_polygon.xpoints[0],
			       d_polygon.ypoints[0]);
	}

	((BackedCanvas) com).getBackingGraphics()
	    .fillPolygon(d_polygon);
	d_polygon = null;
    }

}
