/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a rectangle-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import java.awt.Graphics;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class Rectangle extends Effect {

    private short d_wid;
    private short d_hei;
    private boolean d_fill;


    public Rectangle(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_wid = bs.getShort();
	d_hei = bs.getShort();
	d_fill = bs.getBoolean();
    }

    public void run(Component com) throws EffectException {
	Graphics gr = ((BackedCanvas) com).getBackingGraphics();
	if (d_fill) {
	    gr.fillRect(d_ptX, d_ptY, d_wid, d_hei);
	} else {
	    gr.drawRect(d_ptX, d_ptY, d_wid - 1, d_hei - 1);
	}
    }

}
