/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a relative-draw-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class RelDraw extends Effect {

    private short d_x;
    private short d_y;


    public RelDraw(ByteSequence bs, boolean twobyte)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	if (twobyte) {
	    d_x = bs.getShort();
	    d_y = bs.getShort();
	} else {
	    d_x = (short) bs.getByte();
	    d_y = (short) bs.getByte();
	}
    }

    public void run(Component com) throws EffectException {
	int newx = d_ptX + d_x;
	int newy = d_ptY + d_y;
	if (d_polygon == null) {
	    ((BackedCanvas) com).getBackingGraphics()
		.drawLine(d_ptX, d_ptY, newx, newy);
	} else {
	    d_polygon.addPoint(newx, newy);
	}
	d_ptX = newx;
	d_ptY = newy;
    }

}
