/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a show-icon-effect and its body. */

package cgmud.effect;

import java.awt.Component;
import cgmud.base.ByteSequence;
import cgmud.main.Globals;
import cgmud.ui.IconPane;


public class ShowIcon extends Effect {

    private int d_id;
    private boolean d_monster;


    public ShowIcon(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_id = bs.getInt();
	d_monster = bs.getBoolean();
    }

    public void run(Component com) throws EffectException {
	if (Globals.theIconPane == null) {
	    Globals.theMain.printdiag("ShowIcon but no IconPane");
	    return;
	}
	try {
	    Globals.theIconPane.showIcon(d_id);
	} catch (NullPointerException nx) {
	    Globals.theIconPane.showNewIcon(d_id, d_monster, 
		Globals.thePenSet.getColorint(d_iconPen));
	}
    }

}
