/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a show-image-effect and its body. The numeric
   parms indicate 65536'ths of the total. */

package cgmud.effect;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Image;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class ShowImage extends Effect {

    private String d_file;
    private int d_imx;
    private int d_imy;
    private int d_imwid;
    private int d_imhei;
    private int d_dix;
    private int d_diy;
    private int d_diwid;
    private int d_dihei;


    public ShowImage(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_file = bs.getString();
	d_imx = bs.getInt();
	d_imy = bs.getInt();
	d_imwid = bs.getInt();
	d_imhei = bs.getInt();
	d_dix = bs.getInt();
	d_diy = bs.getInt();
	d_diwid = bs.getInt();
	d_dihei = bs.getInt();
    }

    public void run(Component com) throws EffectException {
	Image im;
	if (d_file.length() != 0) {
	    im = Effect.fetchImage(d_file, com);
	} else {
	    im = d_theImage;
	}
	int ix1 = d_imx * im.getWidth(null) / 0x10000;
	int iy1 = d_imy * im.getHeight(null) / 0x10000;
	int ix2 = (d_imx + d_imwid) * im.getWidth(null) / 0x10000;
	int iy2 = (d_imy + d_imhei) * im.getHeight(null) / 0x10000;
	Dimension siz = com.getSize();
	int dx1 = d_dix * siz.width / 0x10000;
	int dy1 = d_diy * siz.height / 0x10000;
	int dx2 = (d_dix + d_diwid) * siz.width / 0x10000;
	int dy2 = (d_diy + d_dihei) * siz.height / 0x10000;
	((BackedCanvas) com).replaceImage(im, ix1, iy1, ix2, iy2,
					      dx1, dy1, dx2, dy2);
    }

}
