/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */

package cgmud.effect;

import java.awt.Component;
import java.awt.Image;
import cgmud.base.ByteSequence;
import cgmud.ui.BackedCanvas;


public class ShowImagePixels extends Effect {

    private String d_file;
    private short d_imx;
    private short d_imy;
    private short d_imwid;
    private short d_imhei;
    private short d_dix;
    private short d_diy;


    public ShowImagePixels(ByteSequence bs)
    throws EffectException, ArrayIndexOutOfBoundsException
    {
	d_file = bs.getString();
	d_imx = bs.getShort();
	d_imy = bs.getShort();
	d_imwid = bs.getShort();
	d_imhei = bs.getShort();
	d_dix = bs.getShort();
	d_diy = bs.getShort();
    }

    public void run(Component com) throws EffectException {
	Image im;
	if (d_file.length() != 0) {
	    im = Effect.fetchImage(d_file, com);
	} else {
	    im = d_theImage;
	    if (im == null) return;
	}
	int ix1 = d_imx & 0x0000ffff;
	int iy1 = d_imy & 0x0000ffff;
	int ix2 = (d_imx + d_imwid) & 0x0000ffff;
	int iy2 = (d_imy + d_imhei) & 0x0000ffff;
	int dx1 = d_dix & 0x0000ffff;
	int dy1 = d_diy & 0x0000ffff;
	int dx2 = (d_dix + d_imwid) & 0x0000ffff;
	int dy2 = (d_diy + d_imhei) & 0x0000ffff;
	((BackedCanvas) com).replaceImage(im, ix1, iy1, ix2, iy2,
					      dx1, dy1, dx2, dy2);
    }

}
