/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class holds the public global state of cgMUD. */

package cgmud.main;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.io.BufferedOutputStream;
import cgmud.base.Cache;
import cgmud.ui.*;


public class Globals {

    public static Main theMain;

    public static LogFile logFile;

    public static int textRows;
    public static int fontSize;
    public static boolean refocus;

    public static Cache theEffects;
    public static Cache theIcons;
    public static Cache theRegions;
    public static Cache theTiles;

    public static BoxFrame     theFrame;
    public static Font         theFixedFont;
    public static FontMetrics  theFontMetrics;
    public static PenSet       thePenSet;
    public static PromptedText theDefaultPrompter;
    public static GeneralText  theDefaultText;
    public static IconPane     theIconPane;

    public static BufferedOutputStream serverOut;

    public static int sessionState;
	/* These are named after what we expect to get next.
	   CREATION_PW, NEWPLAYER_PW, and OLDPLAYER_PW refer to startup
	   only, not responses to ask-password messages.
	   (Except PLAYING and SHUTDOWN, when we might get anything.) */
	public static final int
	    SESSION_MSG_BEGIN_CLIENT   =  1,
	    SESSION_PLAYER_NAME        =  2,
	    SESSION_MSG_ASK_PLAYER     =  3,
	    SESSION_CONFIRM_NEWPLAYER  =  4,
	    SESSION_CREATION_PW        =  5,
	    SESSION_MSG_CREATION_CHECK =  6,
	    SESSION_NEWPLAYER_PW       =  7,
	    SESSION_MSG_CREATE_PLAYER  =  8,
	    SESSION_MSG_LOGIN_PLAYER   =  9,
	    SESSION_OLDPLAYER_PW       = 10,
	    SESSION_MSG_RUN_CLIENT     = 11,
	    SESSION_MSG_END_CLIENT     = 12,

	    SESSION_PLAYING            = 100,
	    SESSION_SHUTDOWN           = 101;
	/* In this last group of states, the server may send most
	   anything. SESSION_PLAYING is the first-numbered such state. */

    /* ----- constructor ----- */

    public static void make(Main main, int textRowsParm, int fontSizeParm,
			    boolean refocusParm) {
	theMain = main;
	logFile = null;
	textRows = textRowsParm;
	fontSize = fontSizeParm;
	theEffects = new Cache();
	theIcons = new Cache();
	theRegions = new Cache();
	theTiles = new Cache();
	theFrame = null;
	theFixedFont = null;
	thePenSet = new PenSet();
	theDefaultPrompter = null;
	theDefaultText = null;
	theIconPane = null;
	serverOut = null;
	sessionState = 0;
	refocus = refocusParm;
    }

}
