/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class formats message logs. */

package cgmud.main;

import cgmud.base.ByteSequence;


public class LogFormatter {

    private static char[] d_hex = {
	'0', '1', '2', '3', '4', '5', '6', '7',
	'8', '9', 'a', 'b', 'c', 'd', 'e', 'f'
    };

    public static String formatByteSequence(char prefix, ByteSequence bs) {
	StringBuffer sb = new StringBuffer();
	sb.append(prefix);
	sb.append(':');
	byte[] data = bs.getArray();
	for (int ix = 0; ix < data.length; ix += 1) {
	    if (ix < 8) {
		if ((ix == 0) || (ix == 2) || (ix == 6)
		 || (ix == 7) || (ix == 8))
		{
		    sb.append(' ');
		}
	    } else if ((ix % 20) == 10) {
		sb.append("\n   ");
	    } else if ((ix % 4) == 2) {
		sb.append(' ');
	    }
	    sb.append(d_hex[(data[ix] >> 4) & 0x0f]);
	    sb.append(d_hex[(data[ix]     ) & 0x0f]);
	}
	sb.append('\n');
	return sb.toString();
    }

}
