/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a create-component message. */

package cgmud.message;

import cgmud.base.ByteSequence;
import cgmud.effect.Effect;
import cgmud.effect.EffectFormException;
import cgmud.effect.EffectSequence;
import cgmud.main.Globals;
import cgmud.main.Main;


public class CreateComponent extends Message {

    private int d_encloser;
    private short d_width;
    private short d_height;


    /* ----- constructors ----- */

    /* packaged */ CreateComponent(ByteSequence data) {
	super(data);
	setIndex(D_LOC_TAIL);
	try {
	    d_encloser = getInt();
	    d_width = getShort();
	    d_height = getShort();
	} catch (EffectFormException ex) {
	    d_encloser = -1;
	    Globals.theMain.printdiag(ex.toString());
	}
    }


    /* ----- processing ----- */

    public void process(Main main) {
	if (d_encloser == -1) {
	    main.printdiag("malformed create-component message");
	} else {
	    main.addComponent(d_encloser, getKey(), getParmint(),
			      d_width, d_height);
	}
    }

}
