/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a create-container message. */

package cgmud.message;

import cgmud.base.ByteSequence;
import cgmud.effect.Effect;
import cgmud.effect.EffectFormException;
import cgmud.effect.EffectSequence;
import cgmud.main.Globals;
import cgmud.main.Main;


public class CreateContainer extends Message {

    private int d_encloser;


    /* ----- constructors ----- */

    /* packaged */ CreateContainer(ByteSequence data) {
	super(data);
	setIndex(D_LOC_TAIL);
	try {
	    d_encloser = getInt();
	} catch (EffectFormException ex) {
	    d_encloser = -1;
	    Globals.theMain.printdiag(ex.toString());
	}
    }


    /* ----- processing ----- */

    public void process(Main main) {
	if (d_encloser == -1) {
	    main.printdiag("malformed create-container message");
	} else {
	    main.addContainer(d_encloser, getKey(), getFlag(),
			      getParmint());
	}
    }

}
