/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a create-player message. */

package cgmud.message;

import cgmud.base.ByteSequence;
import cgmud.main.Globals;
import cgmud.main.Main;


public class CreatePlayer extends Message {

    private static final int
	DENIED = 0,
	ACCEPTED = 1;

    /* ----- constructors ----- */

    public CreatePlayer(String name, String passwd) {
	super(Message.CREATE_PLAYER, 0, (byte) 0,
	    (short) (PASSWORD_LEN + name.length() + 1));
	appendBlock(PASSWORD_LEN, Crypt.encrypt(passwd));
	appendString(name);
    }

    /* packaged */ CreatePlayer(ByteSequence data) { super(data); }


    /* ----- processing ----- */

    public void process(Main main) {
	if (Globals.sessionState == Globals.SESSION_SHUTDOWN) return;
	if (Globals.sessionState != Globals.SESSION_MSG_CREATE_PLAYER) {
	    main.serverError();
	    return;
	}
	switch (getKey()) {
	    case DENIED:
		main.println("Character " + main.getPlayerName() +
		    " was just created elsewhere!");
		main.requestPlayerName();
		break;
	    case ACCEPTED:
		main.waitForRunClient();
		break;
	    default:
		main.serverError();
		break;
	}
    }

}
