/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a creation-check message. */

package cgmud.message;

import cgmud.base.ByteSequence;
import cgmud.main.Globals;
import cgmud.main.Main;


public class CreationCheck extends Message {

    private static final int
	OK = 0,
	RETRY = 1,
	TOOMANY = 2;

    /* ----- constructors ----- */

    public CreationCheck(String passwd) {
	super(Message.CREATION_CHECK, 0, (byte) 0, (short) PASSWORD_LEN);
	appendBlock(PASSWORD_LEN, Crypt.encrypt(passwd));
    }

    /* packaged */ CreationCheck(ByteSequence data) { super(data); }


    /* ----- processing ----- */

    public void process(Main main) {
	if (Globals.sessionState == Globals.SESSION_SHUTDOWN) return;
	if (Globals.sessionState != Globals.SESSION_MSG_CREATION_CHECK) {
	    main.serverError();
	    return;
	}
	switch (getKey()) {
	    case OK:
		Globals.sessionState = Globals.SESSION_NEWPLAYER_PW;
		main.makePassword();
		break;
	    case RETRY:
		Globals.sessionState = Globals.SESSION_CREATION_PW;
		main.println("Creation password incorrect: re-enter.");
		main.requestPassword(false);
		break;
	    case TOOMANY:
		main.println("Creation password incorrect.");
		main.requestPlayerName();
		break;
	    default:
		main.serverError();
		break;
	}
    }

}
