/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This is the password cryptor of cgMUD. */

package cgmud.message;


public class Crypt {

    private static void m_swapBits(byte[] bs, int ix1, int ix2) {
	byte mask1 = (byte) (1 << (ix1 % 8));
	byte mask2 = (byte) (1 << (ix2 % 8));
	ix1 /= 8;
	ix2 /= 8;
	boolean z1 = (bs[ix1] & mask1) == 0;
	boolean z2 = (bs[ix2] & mask2) == 0;
	if (z1 != z2) {
	    bs[ix1] ^= mask1;
	    bs[ix2] ^= mask2;
	}
    }

    private static void m_twiddle1(byte[] bs) {
	m_swapBits(bs,   0,  11);
	m_swapBits(bs,   1,  97);
	m_swapBits(bs,   2,  33);
	m_swapBits(bs,   4, 142);
	m_swapBits(bs,   5, 116);
	m_swapBits(bs,   6,  13);
	m_swapBits(bs,   7,  58);
	m_swapBits(bs,  12,  29);
	m_swapBits(bs,  16,  60);
	m_swapBits(bs,  17,  36);
	m_swapBits(bs,  18,  94);
	m_swapBits(bs,  19, 102);
	m_swapBits(bs,  24,  50);
	m_swapBits(bs,  26, 118);
	m_swapBits(bs,  27,  83);
	m_swapBits(bs,  32,  85);
	m_swapBits(bs,  34, 125);
	m_swapBits(bs,  35,  90);
	m_swapBits(bs,  38, 113);
	m_swapBits(bs,  44, 153);
	m_swapBits(bs,  45,  78);
	m_swapBits(bs,  46, 111);
	m_swapBits(bs,  47,  63);
	m_swapBits(bs,  48, 149);
	m_swapBits(bs,  49, 151);
	m_swapBits(bs,  51,  74);
	m_swapBits(bs,  52, 134);
	m_swapBits(bs,  54, 103);
	m_swapBits(bs,  55, 119);
	m_swapBits(bs,  56,  64);
	m_swapBits(bs,  62, 104);
	m_swapBits(bs,  65, 126);
	m_swapBits(bs,  70,  89);
	m_swapBits(bs,  71, 135);
	m_swapBits(bs,  72, 150);
	m_swapBits(bs,  76, 130);
	m_swapBits(bs,  77, 133);
	m_swapBits(bs,  79, 127);
	m_swapBits(bs,  80, 136);
	m_swapBits(bs,  87, 115);
	m_swapBits(bs,  92, 132);
	m_swapBits(bs,  93, 106);
	m_swapBits(bs,  95, 107);
	m_swapBits(bs,  98, 139);
	m_swapBits(bs,  99, 112);
	m_swapBits(bs, 109, 128);
	m_swapBits(bs, 114, 141);
	m_swapBits(bs, 131, 140);
	m_swapBits(bs, 138, 156);
    }

    private static void m_twiddle2(byte[] bs) {
	for (int ix = 0; ix < Message.PASSWORD_LEN; ix += 1) {
	    bs[ix] ^= Message.d_sessionKey[ix % 4];
	}
    }

    public static byte[] encrypt(String password) {
	byte[] bs = password.getBytes();
	if (bs.length < Message.PASSWORD_LEN) {
	    byte[] bs2 = new byte[Message.PASSWORD_LEN];
	    System.arraycopy(bs, 0, bs2, 0, bs.length);
	    bs2[bs.length] = 0; // delimiter
	    bs = bs2;
	}
	m_twiddle2(bs);
	m_twiddle1(bs);
	return bs;
    }

    public static String decrypt(byte[] crpass) {
	m_twiddle1(crpass);
	m_twiddle2(crpass);
	StringBuffer sb = new StringBuffer();
	for (int ix = 0; ix < Message.PASSWORD_LEN; ix += 1) {
	    if (crpass[ix] == 0) break;
	    sb.append((char) crpass[ix]);
	}
	return sb.toString();
    }

}
