/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a define-effect-message. */

package cgmud.message;

import cgmud.base.ByteSequence;
import cgmud.effect.Effect;
import cgmud.effect.EffectFormException;
import cgmud.effect.EffectSequence;
import cgmud.main.Globals;
import cgmud.main.Main;


public class DefineEffect extends Message {

    private Effect d_ef;


    /* ----- constructors ----- */

    /* packaged */ DefineEffect(ByteSequence data) {
	super(data);
	setIndex(D_LOC_TAIL);
	int refcount = getByte();
	setIndex(getIndex() + 4 * refcount);
	try {
	    d_ef = new EffectSequence(this);
	} catch (EffectFormException ex) {
	    d_ef = null;
	    Globals.theMain.printdiag(ex.toString());
	}
    }


    /* ----- processing ----- */

    public void process(Main main) {
	if (d_ef != null) {
	    Globals.theEffects.insertItem(getKey(), d_ef);
	}
    }

}
