/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a end-client message.
   Like most "empty" messages, it doesn't need much. */

package cgmud.message;

import cgmud.base.ByteSequence;
import cgmud.main.Globals;
import cgmud.main.Main;


public class EndClient extends Message {

    /* ----- constructors ----- */

    public EndClient() {
	super(Message.END_CLIENT, 0, (byte) 0, (short) 0);
    }

    /* packaged */ EndClient(ByteSequence data) { super(data); }


    /* ----- processing ----- */

    public void process(Main main) {
	if (Globals.sessionState == Globals.SESSION_SHUTDOWN) return;
	if (Globals.sessionState != Globals.SESSION_MSG_END_CLIENT) {
	    main.serverError();
	    return;
	}
	main.stopConnect();
    }

}
