/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a login-player message. */

package cgmud.message;

import cgmud.base.ByteSequence;
import cgmud.main.Globals;
import cgmud.main.Main;


public class LoginPlayer extends Message {

    private static final int
	OK = 0,
	RETRY = 1,
	TOOMANY = 2;

    /* ----- constructors ----- */

    public LoginPlayer(String passwd) {
	super(Message.LOGIN_PLAYER, 0, (byte) 0, (short) PASSWORD_LEN);
	appendBlock(PASSWORD_LEN, Crypt.encrypt(passwd));
    }

    /* packaged */ LoginPlayer(ByteSequence data) { super(data); }


    /* ----- processing ----- */

    public void process(Main main) {
	if (Globals.sessionState == Globals.SESSION_SHUTDOWN) return;
	if (Globals.sessionState != Globals.SESSION_MSG_LOGIN_PLAYER) {
	    main.serverError();
	    return;
	}
	switch (getKey()) {
	    case OK:
		main.waitForRunClient();
		break;
	    case RETRY:
		Globals.sessionState = Globals.SESSION_OLDPLAYER_PW;
		main.println("Player password incorrect: re-enter.");
		main.requestPassword(true);
		break;
	    case TOOMANY:
		main.println("Player password incorrect.");
		main.requestPlayerName();
		break;
	    default:
		main.serverError();
		break;
	}
    }

}
