/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents a Canvas with a backing store. */

package cgmud.ui;

import java.awt.*;
import java.awt.image.ImageObserver;


public class BackedCanvas extends Canvas {

    private Image d_backing;
    private Graphics d_backGraphics; // cached


    /* ----- constructor ----- */

    public BackedCanvas(Font font, int width, int height) {
	setFont(font);
	setSize(width, height);
	d_backing = null; // can't make until peer exists
    }


    /* ----- graphics methods ----- */

    public void addNotify() {
	super.addNotify();
	Dimension dim = getSize();
	d_backing = createImage(dim.width, dim.height);
	d_backGraphics = d_backing.getGraphics();
    }

    public Graphics getBackingGraphics() {
	return d_backGraphics;
    }

    public void replaceImage(Image im, int ix1, int iy1, int ix2, int iy2,
				       int dx1, int dy1, int dx2, int dy2)
    {
	// We can't just do
	//	d_backing = im;
	// because IM might be a loaded image, for which one
	// can't getGraphics(). So...
	getBackingGraphics().drawImage(im, dx1, dy1, dx2, dy2,
					   ix1, iy1, ix2, iy2, null);
	repaint();
    }

    public void paint(Graphics gr) {
	gr.drawImage(d_backing, 0, 0, null);
    }

}
