/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class holds a collection of buttons. */

package cgmud.ui;

import java.awt.*;
import cgmud.base.Cache;
import cgmud.main.Globals;


public class ButtonPanel extends Panel {

    private Cache d_buttons;


    /* ----- constructors ----- */

    public ButtonPanel(Font font, int width, int height) {
	super();
	setLayout(null);
	setSize(width, height);
	setFont(font);
	d_buttons = new Cache();
    }


    /* ----- other methods ----- */

    public void addButton(int id, String text, int px, int py,
			  int forecol, int backcol)
    {
	Button bu = new Button(text);
	bu.setActionCommand("Button#" + id);
	bu.setSize(8 + Globals.theFontMetrics.stringWidth(text),
		   4 + Globals.theFontMetrics.getHeight());
	bu.setForeground(new Color(Globals.thePenSet.getColorint(forecol)));
	bu.setBackground(new Color(Globals.thePenSet.getColorint(backcol)));
	bu.setLocation(px, py);
	bu.addActionListener(Globals.theMain);
	add(bu);
	bu.setVisible(true);
	validate();
	d_buttons.insertItem(id, bu);
    }

    public void removeButton(int id) {
	Button bu = (Button) d_buttons.getItem(id);
	if (bu != null) {
	    d_buttons.removeItem(id);
	    remove(bu);
	    repaint();
	}
    }

    public void clearButtons() {
	d_buttons.clear();
	removeAll();
	repaint();
    }

}
