/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class displays text to the user. It automatically removes text
   when it becomes large. */

package cgmud.ui;

import java.awt.*;


public class GeneralText extends TextArea {

    private static final int MAXLINES = 500;
	// keep the line-quantity between MAXLINES and double MAXLINES

    int d_lines, d_chars;
    int d_removePos;


    /* ----- constructors ----- */

    public GeneralText(Font font, int cols, int rows) {
	super("", rows, cols, SCROLLBARS_VERTICAL_ONLY);
	setFont(font);
	setEditable(false);
	d_lines = 0;
	d_chars = 0;
	d_removePos = 0;
    }


    /* ----- other methods ----- */

    public void appendLine(String line) {
	if (d_lines != 0) {
	    append("\n");
	}
	d_lines += 1;

	append(line);
	d_chars += 1 + line.length();

	// count new-lines in Line
	int ix = line.indexOf('\n', 0);
	while (ix >= 0) {
	    d_lines += 1;
	    ix = line.indexOf('\n', ix+1);
	}

	if (d_lines == MAXLINES) {
	    d_removePos = d_chars;
	} else if (d_lines >= 2*MAXLINES) {
	    replaceRange("", 0, d_removePos);
	    d_chars -= d_removePos;
	    d_lines = MAXLINES;
	    d_removePos = d_chars;
	}
    }

}
