/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class draws icons into itself. It treates the Icon-flag as
   show/don't show. Icons are enlarged to 48x48. */

package cgmud.ui;

import java.awt.*;
import java.awt.image.*;
import java.util.Enumeration;
import cgmud.base.Cache;
import cgmud.main.Globals;


public class IconCanvas extends Canvas {

    private static final int
	D_DRAWSIZE = 32,
	D_MARGIN = 4,
	D_WIDTH = D_DRAWSIZE + 2 * D_MARGIN,
	D_HEIGHT = D_WIDTH,

	D_MAGIC_QUAN = 8; // the minimum icon-size of the canvas


    /* ----- constructor ----- */

    // default constructor


    /* ----- utilities ----- */

    private int m_countVisibles() {
	int viscount = 0;
	for (Enumeration icons = Globals.theIcons.elements();
	     icons.hasMoreElements();
	    )
	{
	    Icon ic = (Icon) icons.nextElement();
	    if (ic.getFlag()) viscount += 1;
	}
	return viscount;
    }


    /* ----- Component overrides ----- */

    public Dimension getPreferredSize() {
	int vis = m_countVisibles();
	if (vis < D_MAGIC_QUAN) vis = D_MAGIC_QUAN;
	return new Dimension(vis * D_WIDTH, D_HEIGHT);
    }

    public void paint(Graphics gr) {
	setSize(getPreferredSize());

	int px = D_MARGIN;
	for (Enumeration icons = Globals.theIcons.elements();
	     icons.hasMoreElements();
	    )
	{
	    Icon ic = (Icon) icons.nextElement();
	    if (ic.getFlag()) {
		gr.drawImage(ic.getImage(),
		    px, D_MARGIN, D_DRAWSIZE, D_DRAWSIZE, this);
		px += D_WIDTH;
	    }
	}
    }

}
