/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class shows a collection of icons. */

package cgmud.ui;

import java.awt.*;
import java.util.Enumeration;
import cgmud.base.Cache;
import cgmud.main.Globals;


public class IconPane extends ScrollPane {

    IconCanvas d_canvas;


    /* ----- constructors ----- */

    public IconPane(int width, int height) {
	super();
	setSize(width, height);
	d_canvas = new IconCanvas();
	add(d_canvas);
    }


    /* ----- inspectors ----- */

    public boolean iconExists(int id) {
	return Globals.theIcons.getItem(id) != null;
    }


    /* ----- icon methods ----- */

    public void showNewIcon(int id, byte[] data, int colorint) {
	Icon ic = new Icon(data, colorint, d_canvas);
	Globals.theIcons.insertItem(id, ic);
	ic.setFlag(true);
	doLayout();
	d_canvas.repaint();
    }

    public void showNewIcon(int id, boolean monster, int colorint) {
	Icon ic = new Icon(monster, colorint, d_canvas);
	Globals.theIcons.insertItem(id, ic);
	ic.setFlag(true);
	doLayout();
	d_canvas.repaint();
    }

    public void deleteIcon(int id) {
	Globals.theIcons.removeItem(id);
	doLayout();
	d_canvas.repaint();
    }


    /* ----- visibility methods ----- */

    public void showIcon(int id) {
	Icon ic = (Icon) Globals.theIcons.getItem(id);
	ic.setFlag(true);
	doLayout();
	d_canvas.repaint();
    }

    public void hideIcon(int id) {
	Icon ic = (Icon) Globals.theIcons.getItem(id);
	ic.setFlag(false);
	doLayout();
	d_canvas.repaint();
    }

    public void hideAllIcons() {
	for (Enumeration icons = Globals.theIcons.elements();
	     icons.hasMoreElements();
	    )
	{
	    Icon ic = (Icon) icons.nextElement();
	    ic.setFlag(false);
	}
	doLayout();
	d_canvas.repaint();
    }

}
