/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class is a Frame which prompts for a string. */

package cgmud.ui;

import java.awt.*;
import java.awt.event.*;
import cgmud.main.Main;
import cgmud.main.Globals;


public class StringRequester extends Frame
    implements ActionListener, KeyListener
{

    Main d_main;
    TextField d_typeArea;


    /* ----- constructor ----- */

    public StringRequester(Main main, String label, String def) {
	super(label);
	setSize(500, 90);
	d_main = main;
	d_typeArea = new TextField(def);
	    d_typeArea.addKeyListener(this);
	Button cancelButton = new Button("Cancel");
	    cancelButton.addActionListener(this);
	add(BorderLayout.CENTER, d_typeArea);
	add(BorderLayout.SOUTH, cancelButton);
	setVisible(true);
    }


    /* ----- utilities ----- */

    private void m_goAway() {
	setVisible(false);
	dispose();
    }


    /* ----- ActionListener interface ----- */

    public void actionPerformed(ActionEvent ev) {
	String command = ev.getActionCommand();
	if (command.equals("Cancel")) {
	    d_main.stringCancelled();
	    m_goAway();
	}
    }


    /* ----- KeyListener interface ----- */

    public void keyReleased(KeyEvent ke) { }
    public void keyTyped(KeyEvent ke) { }

    public void keyPressed(KeyEvent ke) {
	int kc = ke.getKeyCode();
	switch (kc) {
	    case KeyEvent.VK_ENTER:
		d_main.stringGiven(d_typeArea.getText());
		ke.consume();
		m_goAway();
		return;
	}
    }

}
