/* Copyright 1999 by Donald Reble. All rights reserved. */

/* $Id: $ */
/* This class represents an tile: a rectangular pixelmap, one byte per
   pixel. The zero'th color is transparent. The constructor takes a
   Component parameter: its peer must already exist. */

package cgmud.ui;

import java.awt.*;
import java.awt.image.*;
import cgmud.main.Globals;


public class Tile {

    private Image d_image;


    /* ----- constructor ----- */

    public Tile(int wid, int hei, byte[] pixmap, short xpar,
		Component drawon)
    {
	byte[] colormap = new byte[3 * PenSet.PEN_QUAN];
	for (int cx = 0; cx < PenSet.PEN_QUAN; cx += 1) {
	    int co = Globals.thePenSet.getColorint(cx);
	    colormap[3*cx+0] = (byte) (co >> 16);
	    colormap[3*cx+1] = (byte) (co >> 8);
	    colormap[3*cx+2] = (byte)  co;
	}
	IndexColorModel icm = new IndexColorModel
	    (PenSet.PEN_QUAN_LG, PenSet.PEN_QUAN, colormap,
	     /* start */ 0, /* hasalpha */ false,
	     /* transparent */ (int) xpar);

	MemoryImageSource mis = new MemoryImageSource
	    (wid, hei, icm, pixmap, 0, wid);
	d_image = drawon.createImage(mis);
    }


    /* ----- inspectors ----- */

    public Image getImage() { return d_image; }

}
